#!/usr/bin/env python3

import sys
from math import factorial
from decimal import Decimal, getcontext

printAll = False
if len(sys.argv) == 2:
    numberOfDigits = int(sys.argv[1])
elif len(sys.argv) == 3:
    numberOfDigits = int(sys.argv[1])
    if sys.argv[2] == "-print":
        printAll = True
else:
    print("Not enough arguments!")
    sys.exit(0)

getcontext().prec=numberOfDigits

def Pi(n):
    t = Decimal(0)
    pi = Decimal(0)
    deno = Decimal(0)
    k = 0
    n = int(n / 20)
    for k in range(n):
        t = ((-1)**k)*(factorial(6*k))*(13591409+545140134*k)
        denominator = factorial(3*k)*(factorial(k)**3)*(640320**(3*k))
        pi += Decimal(t)/Decimal(denominator)
        if printAll == True:
            print(pi)
    pi = pi * Decimal(12)/Decimal(640320**Decimal(1.5))
    pi = 1/pi
    return pi

print(Pi(numberOfDigits))
